#include <iostream>
 #include <algorithm>

 using namespace std;

 int main() {

     int brojNabavki, brojKontrolnihDana;
     cin >> brojNabavki >> brojKontrolnihDana;


     int daniNabavki[300000];
     int kolicineNabavki[300000];


     for (int i = 0; i < brojNabavki; ++i) {
         cin >> daniNabavki[i] >> kolicineNabavki[i];
     }


     int kontrolniDani[1000];
     for (int i = 0; i < brojKontrolnihDana; ++i) {
         cin >> kontrolniDani[i];
     }


     int pojedenaPlazma = 0;
     int zaliha = 0;
     int trenutniDan = 0;
     int indeksNabavke = 0;


     for (int i = 0; i < brojKontrolnihDana; ++i) {
         int kontrolniDan = kontrolniDani[i];


         while (trenutniDan < kontrolniDan) {

             trenutniDan++;


             while (indeksNabavke < brojNabavki && daniNabavki[indeksNabavke] == trenutniDan) {
                 zaliha += kolicineNabavki[indeksNabavke];
                 indeksNabavke++;
             }


             if (zaliha > 0) {
                 zaliha--;
                 pojedenaPlazma++;
             }
         }


         cout << pojedenaPlazma << endl;
     }

     return 0;
 }